public class CromossomoBloco extends Cromossomo {
    private static int nGenes = 3;
    private static int nCores = 2;
  
    private void setCromossomoToArray(Bloco[] b){
        System.out.println(this.toString());
        for (int i=0; i<nGenes; i++){
            b[i] = new Bloco((int)converteBooleano(i*nBitsPorGene(nCores),(i+1)*nBitsPorGene(nCores)-1));
        } 
    }

    public void imprimeBlocos(){
        Bloco b[] = new Bloco[nGenes];
        setCromossomoToArray(b);
        for (int i=0;i<nGenes;i++){
            System.out.println("Bloco n " + i + " vale: " + b[i].getCor());
        }
    }


    public double calculaAvaliacao(){
        Bloco[] blocos = new Bloco[nGenes];           
        int resultado=0;
        
        setCromossomoToArray(blocos);
        
        // regra 1: A != B
        if (!(blocos[0].equals(blocos[1])) )
            resultado++;

        // regra 2: A != C
        if (!(blocos[0].equals(blocos[2])) )
            resultado++;

        this.avaliacao = resultado;
        return resultado;
    }



    /****************/
    /* Construtores */
    /****************/
    
    public CromossomoBloco() {
        super(nBitsPorGene(nCores)*nGenes);   //para 4 rainhas
    }
    
    public CromossomoBloco(int tamanho){
        super(tamanho);
    }
    
    
    public static void main(String args[]){
        CromossomoBloco c = new CromossomoBloco();
        c.calculaAvaliacao();
        c.imprimeBlocos();
        System.out.println(c.toString() + " ");        
        
    }
    
}
